package de.uniulm.mathematik.typo.items;

/**
 * ItemWrapper class that wraps all objects into instances
 * of the BorderdItem class.
 */
public class BorderingWrapper implements ItemWrapper {
   private int border;

   /**
    * Construct a wrapper with the given border thickness.
    * @param border Thickness of the border in units (1/1000 units).
    *               The border must be non-negative.
    */
   public BorderingWrapper(int border) {
      assert(border >= 0);
      this.border = border;
   }

   public Item wrap(Item item) {
      return new BorderedItem(item, border);
   }
} // class BorderingWrapper
