package de.uniulm.mathematik.typo.items;

import java.util.*;
import de.uniulm.mathematik.typo.fonts.*;

/**
 * Instances of this class add visible representations of the baseline
 * in addition to the drawing of the encapsulated object.
 */
public class LinedItem extends DelegatingItem {

   /**
    * Construct a wrapper object that wraps item and overrides
    * the genPostScript() method.
    */
   public LinedItem(Item item) {
      super(item);
   }

   /**
    * Draw the original object and add a visible representation
    * of the baseline to it.
    */
   public StringBuffer genPostScript(PostScriptContext context) {
      if (item.getWidth() <= 0) {
	 return item.genPostScript(context);
      }
      StringBuffer result = new StringBuffer("");
      result.append(context.gsave());
      result.append("currentpoint newpath moveto\n");
      result.append(((double) item.getWidth() / 1000) + " 0 rlineto\n");
      result.append("1 0 1 setrgbcolor\n");
      result.append("stroke\n");
      result.append(context.grestore());
      result.append(item.genPostScript(context));
      return result;
   }
} // class LinedItem
